COMMON_INCLUDES = -I . -I ./include
SOURCES= srvsvc_call.c dssetup_call.c wkssvc_call.c lsa_call.c netlogon_ccall.c hvrpc.c
IDLSOURCES=srvsvc.idl dssetup.idl wkssvc.idl lsa.idl netlogon.idl
OBJECTS=$(SOURCES:.c=.o)
IDLHEADERS=$(IDLSOURCES:.idl=.h)
OBJLIB=../libhvrpc.so
CFLAGS += $(COMMON_INCLUDES) -I $(DCERPC_BASE)/include
#CFLAGS+= -Wfatal-errors
CFLAGS+= -shared -fPIC

all: $(OBJLIB)

$(OBJLIB): $(OBJECTS) 
	$(CC) -shared -fPIC -o $(OBJLIB) $(OBJECTS)
#	$(AR) $(ARFLAGS) $(OBJLIB) $?
#	$(RANLIB) $(OBJLIB)

srvsvc_call.o: srvsvc_sstub.c $(IDLHEADERS) ../include/hvrpc.h

srvsvc_sstub.c: srvsvc.idl srvsvc.acf
	$(DCEIDL) $< -client none $(COMMON_INCLUDES) -keep c_source

dssetup_call.o: dssetup_sstub.c $(IDLHEADERS) ../include/hvrpc.h

dssetup_sstub.c: dssetup.idl dssetup.acf
	$(DCEIDL) $< -client none $(COMMON_INCLUDES) -keep c_source

lsa_call.o: lsa_sstub.c $(IDLHEADERS) ../include/hvrpc.h

lsa_sstub.c: lsa.idl lsa.acf
	$(DCEIDL) $< -client none $(COMMON_INCLUDES) -keep c_source

wkssvc_call.o: wkssvc_sstub.c $(IDLHEADERS) ../include/hvrpc.h

wkssvc_sstub.c: wkssvc.idl wkssvc.acf
	$(DCEIDL) $< -client none $(COMMON_INCLUDES) -keep c_source

netlogon_ccall.o: netlogon_cstub.c $(IDLHEADERS) ../include/hvrpc.h

netlogon_cstub.c: netlogon.idl netlogon.acf
	$(DCEIDL) $< -client all $(COMMON_INCLUDES) -keep c_source


$(IDLHEADERS):
	touch $@

libclean:
	rm -f *.o *sstub.c $(IDLHEADERS) $(OBJLIB)
