#ifdef VMS
#pragma nostandard
#endif
#include <dce/idlddefs.h>
#include <lw/types.h>
#include <lw/security-types.h>
#include <lw/rpc/dssetup.h>

#include "dssetup.h"


#include <stdio.h>
#include <wchar.h>

#include "hvauth.h"
#include "hvrpcint.h"

extern WINERROR DsrRoleGetPrimaryDomainInformation(
    /* [in] */ handle_t IDL_handle,
    /* [in] */ WORD swLevel,
    /* [out] */ DSR_ROLE_INFO **ppInfo
        ) {
	DSR_ROLE_INFO *info = malloc(sizeof(*info));
	*ppInfo = info;

	memset(info, 0, sizeof(*info));
	printf("%s called swLevel %d ppInfo %p\n", __FUNCTION__, (int)swLevel, ppInfo);
	if (swLevel == 1) {
		const char *domain_name = auth_get_domain();

		if (domain_name) {
			info->Basic.dwRole = DS_ROLE_MEMBER_SERVER;
			info->Basic.dwFlags = 3;
			info->Basic.pwszDomain = hvrpc_string(domain_name);
			info->Basic.pwszDnsDomain = hvrpc_string(domain_name);
			info->Basic.pwszForest = hvrpc_string(domain_name);
			((uint64_t *)&info->Basic.DomainGuid)[1] = 0x1c6d20891530399fL;
			((uint64_t *)&info->Basic.DomainGuid)[0] = 0x4eb610fcf12911a8;
		} else {
			info->Basic.dwRole = DS_ROLE_STANDALONE_SERVER;
			info->Basic.dwFlags = 3;
			info->Basic.pwszDomain = NULL;
			info->Basic.pwszDnsDomain = NULL;
			info->Basic.pwszForest = NULL;
		}

	}

	return 0;
}


#include "dssetup_sstub.c"
