#ifdef VMS
#pragma nostandard
#endif
#include "srvsvc.h"
#include <dce/idlddefs.h>

#include <stdio.h>
#include <wchar.h>

#include "hvrpcint.h"
#include "hvbase.h"
#include "share.h"

void _srvsvc_Function0(
    /* [in] */ handle_t IDL_handle
	) {
}

void _srvsvc_Function1(
    /* [in] */ handle_t IDL_handle
	) {
}

void _srvsvc_Function2(
    /* [in] */ handle_t IDL_handle
	) {
}

void _srvsvc_Function3(
    /* [in] */ handle_t IDL_handle
	) {
}

void _srvsvc_Function4(
    /* [in] */ handle_t IDL_handle
	) {
}

void _srvsvc_Function5(
    /* [in] */ handle_t IDL_handle
	) {
}

void _srvsvc_Function6(
    /* [in] */ handle_t IDL_handle
	) {
}

void _srvsvc_Function7(
    /* [in] */ handle_t IDL_handle
	) {
}

WINERROR _NetrConnectionEnum(
    /* [in] */ handle_t IDL_handle,
    /* [in] */ wchar16_t *server_name,
    /* [in] */ wchar16_t *qualifier,
    /* [in, out] */ UINT32 *level,
    /* [in, out] */ srvsvc_NetConnCtr *ctr,
    /* [in] */ UINT32 prefered_maximum_length,
    /* [out] */ UINT32 *total_entries,
    /* [in, out] */ UINT32 *resume_handle
	) {
	return 0;
}

WINERROR _NetrFileEnum(
    /* [in] */ handle_t IDL_handle,
    /* [in] */ wchar16_t *server_name,
    /* [in] */ wchar16_t *basepath,
    /* [in] */ wchar16_t *username,
    /* [in, out] */ UINT32 *level,
    /* [in, out] */ srvsvc_NetFileCtr *ctr,
    /* [in] */ UINT32 prefered_maximum_length,
    /* [out] */ UINT32 *total_entries,
    /* [in, out] */ UINT32 *resume_handle
	) {
	return 0;
}

WINERROR _NetrFileGetInfo(
    /* [in] */ handle_t IDL_handle,
    /* [in] */ wchar16_t *server_name,
    /* [in] */ UINT32 fileid,
    /* [in] */ UINT32 level,
    /* [out] */ srvsvc_NetFileInfo *info
	) {
	return 0;
}

WINERROR _NetrFileClose(
    /* [in] */ handle_t IDL_handle,
    /* [in] */ wchar16_t *server_name,
    /* [in] */ UINT32 fileid
	) {
	return 0;
}

WINERROR _NetrSessionEnum(
    /* [in] */ handle_t IDL_handle,
    /* [in] */ wchar16_t *server_name,
    /* [in] */ wchar16_t *unc_client_name,
    /* [in] */ wchar16_t *username,
    /* [in, out] */ UINT32 *level,
    /* [in, out] */ srvsvc_NetSessCtr *ctr,
    /* [in] */ UINT32 prefered_maximum_length,
    /* [out] */ UINT32 *total_entries,
    /* [in, out] */ UINT32 *resume_handle
	) {
	return 0;
}

WINERROR _NetrSessionDel(
    /* [in] */ handle_t IDL_handle,
    /* [in] */ wchar16_t *server_name,
    /* [in] */ wchar16_t *unc_client_name,
    /* [in] */ wchar16_t *username
	) {
	return 0;
}

WINERROR _NetrShareAdd(
    /* [in] */ handle_t IDL_handle,
    /* [in] */ wchar16_t *server_name,
    /* [in] */ UINT32 level,
    /* [in] */ srvsvc_NetShareInfo info,
    /* [in, out] */ UINT32 *parm_error
	) {
	return 0;
}

/*
 * Callback for share_listwalk
 */
void CallbackShareWalker(int index, ShareInfo *share, void *opaque) {
	srvsvc_NetShareCtr *ctr = (srvsvc_NetShareCtr *)opaque;
	srvsvc_NetShareCtr1 *ctr1 = ctr->ctr1;

	SMBLOG(SMBLOG_INFO, "%s: index %d share %p name [%s] type %d flags %x opaque %p\n", __FUNCTION__, index, share, (share)?share->ShareName:"NULL", 
		   (int)(share?share->Type:0), share?share->Flags:0, opaque);

	// ShareWalker is initially called with the number of shares
	if (!share) {
		ctr1->count = index;
		ctr1->array = malloc(sizeof(*ctr1->array) * ctr1->count);
	} else if (ctr1->array) {
		SHARE_INFO_1 *info = &ctr1->array[index];

		info->shi1_netname = hvrpc_string(share->ShareName);
		if (share->Type == SHARE_TYPE_PIPE) {
			info->shi1_type = 3; // PIPE
		} else {
			info->shi1_type = 0; // DISK
		}
		info->shi1_remark = hvrpc_string(share->Remark);
	}
}

WINERROR _NetrShareEnum(
    /* [in] */ handle_t IDL_handle,
    /* [in] */ wchar16_t *server_name,
    /* [in, out] */ UINT32 *level,
    /* [in, out] */ srvsvc_NetShareCtr *ctr,
    /* [in] */ UINT32 prefered_maximum_length,
    /* [out] */ UINT32 *total_entries,
    /* [in, out] */ UINT32 *resume_handle
	) {
	srvsvc_NetShareCtr1 *ctr1 = ctr->ctr1;	
	ctr1->array = NULL;
	SMBLOG(SMBLOG_INFO, "%s called level %d server %p ctr %p ctr1 %p\n", __FUNCTION__, *level, server_name, ctr, ctr1);
	
	share_listwalk(CallbackShareWalker, ctr, 0);

	if (total_entries) {
		*total_entries = ctr1->count;
	}

	if (resume_handle) {
		*resume_handle = 0;
	}

	return 0;
}

WINERROR _NetrShareGetInfo(
    /* [in] */ handle_t IDL_handle,
    /* [in] */ wchar16_t *server_name,
    /* [in] */ wchar16_t *netname,
    /* [in] */ UINT32 level,
    /* [out] */ srvsvc_NetShareInfo *info
	) {
	printf("%s called level %d info %p!\n", __FUNCTION__, level, info);
	return 0;
}

WINERROR _NetrShareSetInfo(
    /* [in] */ handle_t IDL_handle,
    /* [in] */ wchar16_t *server_name,
    /* [in] */ wchar16_t *netname,
    /* [in] */ UINT32 level,
    /* [in] */ srvsvc_NetShareInfo info,
    /* [in, out] */ UINT32 *parm_error
	) {
	return 0;
}

WINERROR _NetrShareDel(
    /* [in] */ handle_t IDL_handle,
    /* [in] */ wchar16_t *server_name,
    /* [in] */ wchar16_t *netname,
    /* [in] */ UINT32 reserved
	) {
	return 0;
}

void _srvsvc_Function13(
    /* [in] */ handle_t IDL_handle
	) {
}

void _srvsvc_Function14(
    /* [in] */ handle_t IDL_handle
	) {
}

WINERROR _NetrServerGetInfo(
    /* [in] */ handle_t IDL_handle,
    /* [in] */ wchar16_t *server_name,
    /* [in] */ UINT32 level,
    /* [out] */ srvsvc_NetSrvInfo *info
	) {
	info->info101 = malloc(sizeof(*info->info101));
	SERVER_INFO_101 *info101 = info->info101;	
	//const char *srvname = "MYSERVER";

	printf("%s called level %d server %p info %p info101 %p\n", __FUNCTION__, level, server_name, info, info101);
	info101->sv101_platform_id = 500;
	info101->sv101_name  = hvrpc_string("HVDEV2");
	info101->sv101_comment = hvrpc_string("Development and test HVNAS server");
	info101->sv101_version_major = 4;
	info101->sv101_version_minor = 1;
	info101->sv101_type = 0x9003;

	return 0;
}

WINERROR _NetrServerSetInfo(
    /* [in] */ handle_t IDL_handle,
    /* [in] */ wchar16_t *server_name,
    /* [in] */ UINT32 level,
    /* [in] */ srvsvc_NetSrvInfo info,
    /* [in, out] */ UINT32 *parm_error
	) {
	return 0;
}

void _srvsvc_Function17(
    /* [in] */ handle_t IDL_handle
	) {
}

void _srvsvc_Function18(
    /* [in] */ handle_t IDL_handle
	) {
}

void _srvsvc_Function19(
    /* [in] */ handle_t IDL_handle
	) {
}

void _srvsvc_Function1a(
    /* [in] */ handle_t IDL_handle
	) {
}

void _srvsvc_Function1b(
    /* [in] */ handle_t IDL_handle
	) {
}

WINERROR _NetrRemoteTOD(
    /* [in] */ handle_t IDL_handle,
    /* [in] */ wchar16_t *server_name,
    /* [out] */ TIME_OF_DAY_INFO **info
	) {
	return 0;
}

void _srvsvc_Function1d(
    /* [in] */ handle_t IDL_handle
	) {
}

void _srvsvc_Function1e(
    /* [in] */ handle_t IDL_handle
	) {
}

void _srvsvc_Function1f(
    /* [in] */ handle_t IDL_handle
	) {
}

void _srvsvc_Function20(
    /* [in] */ handle_t IDL_handle
	) {
}

WINERROR _NetrNameValidate(
    /* [in] */ handle_t IDL_handle,
    /* [in] */ wchar16_t *server_name,
    /* [in] */ wchar16_t *name,
    /* [in] */ UINT32 type,
    /* [in] */ UINT32 flags
	) {
	return 0;
}


#include "srvsvc_sstub.c"
